// I8123WCPSDIDemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "I8123WCPSDIDemo.h"
#include "I8123WCPSDIDemoDlg.h"
#include "PACSDK.h"
#include "I8123CPS.h"
#include "I8120.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//Base variables
int iCPS_Slot;
CString csTmp;


/////////////////////////////////////////////////////////////////////////////
// CI8123WCPSDIDemoDlg dialog

CI8123WCPSDIDemoDlg::CI8123WCPSDIDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CI8123WCPSDIDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CI8123WCPSDIDemoDlg)
	m_txtNodeID = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CI8123WCPSDIDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CI8123WCPSDIDemoDlg)
	DDX_Control(pDX, IDC_COMBOCPSSlot, m_cmbCPSSlot);
	DDX_Control(pDX, IDC_COMBOBaud, m_cmbBaud);
	DDX_Text(pDX, IDC_EDITNodeID, m_txtNodeID);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CI8123WCPSDIDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CI8123WCPSDIDemoDlg)
	ON_BN_CLICKED(IDC_BTNInit, OnBTNInit)
	ON_BN_CLICKED(IDC_BTNRestore, OnBTNRestore)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CI8123WCPSDIDemoDlg message handlers

CRITICAL_SECTION  AccessI8123WCPS_cs;

BOOL CI8123WCPSDIDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	m_cmbCPSSlot.SetCurSel(1);
	m_cmbBaud.SetCurSel(8);
	m_txtNodeID=_T("1");
	return TRUE;  // return TRUE  unless you set the focus to a control
}


void MyDPRAMIntt(void)
{
	BYTE InttType,DataLen=0;
	int Cmd,iRet,i=0;
	WORD DataAddr=0;
	short tmpDataAddr;

	I8120_ReadUserInttType(iCPS_Slot, &InttType);
	if (InttType==CAN_COMM_CMD_FROM_I8120){ //Check if the main control unit got any command from the I-8120W
		EnterCriticalSection(&AccessI8123WCPS_cs);
		//This is used to avoid mulit-accessing the same I-8120W
        //in the different functions or threads simultaneously. It is useless 
        //while the functions or threads access the I-8120W with different slot.
		Cmd=I8123CPS_CheckDOAOCmd(iCPS_Slot,&DataAddr,&DataLen); //Get command from I-8120W
		LeaveCriticalSection(&AccessI8123WCPS_cs);
		if(Cmd)	//1:DO, 2:AO
		{
			switch(Cmd)
			{
				case 1:	//DO
				break;
				
				case 2:	//AO
				break;
			}
		}
	}
	
}

void CI8123WCPSDIDemoDlg::OnBTNInit() 
{
	// TODO: Add your control notification handler code here
		// TODO: Add your control notification handler code here
	unsigned short DI_Ch;
	unsigned short AI_Ch;
	unsigned short DO_Ch;
	unsigned short AO_Ch;
	unsigned char NodeID, Baud;
	CString ErrMsg,Title;
	static BYTE SendBuf[10],RecBuf[512];
	int i,Ret;
	static WORD RecLen;
	char cTmp[10];

	Baud = m_cmbBaud.GetCurSel();
	//NodeID = 1;
	wcstombs(cTmp,m_txtNodeID,10);
	NodeID=(unsigned char)atoi(cTmp);
	iCPS_Slot = m_cmbCPSSlot.GetCurSel();
	EnterCriticalSection(&AccessI8123WCPS_cs);
		Ret=I8123CPS_CANopenInit((BYTE)iCPS_Slot,Baud);
	LeaveCriticalSection(&AccessI8123WCPS_cs);
	if (Ret){
		ErrMsg.Format(_T("Reset I-8120W hardware of slot %d fail, error code %d\r\n"),iCPS_Slot,Ret);
		MessageBox(ErrMsg,MB_OK);
		return;
	}
	EnterCriticalSection(&AccessI8123WCPS_cs);
		Ret=I8123CPS_InstallUserISR((unsigned char)iCPS_Slot,MyDPRAMIntt); //Install the user's ISR routine 
	LeaveCriticalSection(&AccessI8123WCPS_cs);
	
	 if (Ret){
		ErrMsg.Format(_T("Reset I-8120W hardware of slot %d fail, error code %d\r\n"),iCPS_Slot,Ret);
		MessageBox(ErrMsg,MB_OK);
		return;
	}
	
	Title.Format(_T("I-8123-CPS Demo For User-defined Firmware at Slot %d"), iCPS_Slot);
	SetWindowText(Title); //modify the title of the dialog
    DI_Ch = 16;
    AI_Ch = 0;
    DO_Ch = 16;
    AO_Ch = 0;
	EnterCriticalSection(&AccessI8123WCPS_cs);
		Ret = I8123CPS_IOInit((BYTE)iCPS_Slot,NodeID, DI_Ch, AI_Ch, DO_Ch, AO_Ch,1000);
	LeaveCriticalSection(&AccessI8123WCPS_cs);
	
	if (Ret){
		ErrMsg.Format(_T("IO init error of slot %d fail, error code %d\r\n"),iCPS_Slot,Ret);
		MessageBox(ErrMsg,MB_OK);
		return;
	}
	
	UpdateData(true);
}

void CI8123WCPSDIDemoDlg::OnBTNRestore() 
{
	// TODO: Add your control notification handler code here
	EnterCriticalSection(&AccessI8123WCPS_cs);
	I8120_RestoreI8120((BYTE)iCPS_Slot);
	LeaveCriticalSection(&AccessI8123WCPS_cs);
	
}
